#!/bin/sh

#
# OBJECT DIRECTORIES
#
mkdir glibc_shared
mkdir glibc_static

#
# SOURCE FILES
#
tar xzf orig/glibc-2.0.7-981012.tar.gz
cd glibc-2.0.7/
tar xzf ../orig/glibc-localedata-2.0.7pre3.tar.gz
tar xzf ../orig/glibc-linuxthreads-2.0.7pre5.tar.gz
tar xzf ../orig/glibc-crypt-2.0.6.tar.gz
tar xzf ../orig/linux-include-2.1.76.tar.gz
tar xzf ../orig/glibc-2.0.7-db-mans.tar.gz

#
# PATCHES
#
patch -p1 < ../orig/glibc-2.0.7-preload.patch 
patch -p0 < ../orig/glibc-2.0.7-nonmt.patch
patch -p1 < ../orig/glibc-2.0.7-localedata.patch 
patch -p1 < ../orig/glibc-2.0.7-misc.patch 
patch -p1 < ../orig/glibc-2.0.7-tz.patch 
patch -p1 < ../orig/glibc-2.0.6-threads.patch 
patch -p1 < ../orig/glibc-2.0.7-pagesize.patch 
patch -p1 < ../orig/glibc-2.0.7-slovak.patch 
patch -p1 < ../orig/glibc-2.0.7-serbian.patch 
patch -p1 < ../orig/glibc-2.0.7-shaper.patch 

#
# LINKS
#
ln -s asm-i386 linux/include/asm
ln -s ../../../../linux/include/linux sysdeps/unix/sysv/linux/linux
ln -s ../../../../linux/include/asm sysdeps/unix/sysv/linux/asm

#
# CONFIGURING AND BUILDING
#
autoconf
CFLAGS="-O2 -g -DNDEBUG=1" ./configure \
   --enable-add-ons=yes --enable-profile --prefix=/usr
make -r

#
# GRABBING THE OBJECTS
#
find libio -name "*.so" | sed "s|libio/||" > ../glibc_shared.list
find libio -name "*.o" | sed "s|libio/||" > ../glibc_static.list

#
# yeah, this is a little unnecessary in this case, but it might pay off
# later...
#
cd ../glibc_shared
for F in `cat ../glibc_shared.list`; do ar x ../glibc-2.0.7/libc_pic.a $F; done
cd ../glibc_static
for F in `cat ../glibc_static.list`; do ar x ../glibc-2.0.7/libc.a $F; done

