#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

/* GLOBALS */
static fd_set act_set;
static int act_set_max;
fd_set *active_p;


int is_active(int s)
{
	return(FD_ISSET(s, &act_set));
}

int set_active(int s)
{
	static int init = 1;

	if (init) {	
		act_set_max = 0;
		FD_ZERO(&act_set);
		init = 0;
	}

	FD_SET(s, &act_set);
	if (s >= act_set_max) act_set_max = s+1;
	return(1);
}

int clr_active(int s)
{
	FD_CLR(s, &act_set);
	if (s+1 >= act_set_max) /* need to reduce act_set_max */ {
		int i;
		for (i=s; i >= 0; i--) if (FD_ISSET(i, &act_set)) break;
		act_set_max = i+1;
	}
	return(1);
}

